diff --git a/contrib/ntp/ntpd/ntpd-opts.h b/contrib/ntp/ntpd/ntpd-opts.h
index 3541255bb6fb..99fb3dcd230f 100644
--- a/contrib/ntp/ntpd/ntpd-opts.h
+++ b/contrib/ntp/ntpd/ntpd-opts.h
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (ntpd-opts.h)
  *
- *  It has been AutoGen-ed  June  6, 2023 at 04:36:50 AM by AutoGen 5.18.16
+ *  It has been AutoGen-ed  May 25, 2024 at 12:03:08 AM by AutoGen 5.18.16
  *  From the definitions    ntpd-opts.def
  *  and the template file   options
  *
@@ -18,7 +18,7 @@
  * The ntpd program is copyrighted and licensed
  * under the following terms:
  *
- *  Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation, all rights reserved.
+ *  Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation, all rights reserved.
  *  This is free software. It is licensed for use, modification and
  *  redistribution under the terms of the NTP License, copies of which
  *  can be seen at:
@@ -114,9 +114,9 @@ typedef enum {
 /** count of all options for ntpd */
 #define OPTION_CT    38
 /** ntpd version */
-#define NTPD_VERSION       "4.2.8p17"
+#define NTPD_VERSION       "4.2.8p18"
 /** Full ntpd version text */
-#define NTPD_FULL_VERSION  "ntpd 4.2.8p17"
+#define NTPD_FULL_VERSION  "ntpd 4.2.8p18"
 
 /**
  *  Interface defines for all options.  Replace "n" with the UPPER_CASED
diff --git a/contrib/ntp/ntpd/ntpd.1ntpdman b/contrib/ntp/ntpd/ntpd.1ntpdman
index 237a9179f62e..6d91d5725284 100644
--- a/contrib/ntp/ntpd/ntpd.1ntpdman
+++ b/contrib/ntp/ntpd/ntpd.1ntpdman
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH ntpd 1ntpdman "06 Jun 2023" "4.2.8p17" "User Commands"
+.TH ntpd 1ntpdman "25 May 2024" "4.2.8p18" "User Commands"
 .\"
 .\" EDIT THIS FILE WITH CAUTION (in-mem file)
 .\"
-.\" It has been AutoGen-ed June 6, 2023 at 04:37:49 AM by AutoGen 5.18.16
+.\" It has been AutoGen-ed May 25, 2024 at 12:04:07 AM by AutoGen 5.18.16
 .\" From the definitions ntpd-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
@@ -979,7 +979,7 @@ RFC5908
 .SH "AUTHORS"
 The University of Delaware and Network Time Foundation
 .SH "COPYRIGHT"
-Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .SH BUGS
 The
diff --git a/contrib/ntp/ntpd/ntpd.1ntpdmdoc b/contrib/ntp/ntpd/ntpd.1ntpdmdoc
index 536e7f672840..90e08b7aa825 100644
--- a/contrib/ntp/ntpd/ntpd.1ntpdmdoc
+++ b/contrib/ntp/ntpd/ntpd.1ntpdmdoc
@@ -1,9 +1,9 @@
-.Dd June 6 2023
+.Dd May 25 2024
 .Dt NTPD 1ntpdmdoc User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntpd-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  June  6, 2023 at 04:37:36 AM by AutoGen 5.18.16
+.\"  It has been AutoGen-ed  May 25, 2024 at 12:03:54 AM by AutoGen 5.18.16
 .\"  From the definitions    ntpd-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
@@ -886,7 +886,7 @@ A snapshot of this documentation is available in HTML format in
 .Sh "AUTHORS"
 The University of Delaware and Network Time Foundation
 .Sh "COPYRIGHT"
-Copyright (C) 1992\-2023 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992\-2024 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .Sh BUGS
 The
diff --git a/contrib/ntp/ntpd/ntpd.c b/contrib/ntp/ntpd/ntpd.c
index e58a0613bdcc..b64caae06da1 100644
--- a/contrib/ntp/ntpd/ntpd.c
+++ b/contrib/ntp/ntpd/ntpd.c
@@ -101,16 +101,6 @@
 #include "recvbuff.h"
 #include "ntp_cmdargs.h"
 
-#if 0				/* HMS: I don't think we need this. 961223 */
-#ifdef LOCK_PROCESS
-# ifdef SYS_SOLARIS
-#  include <sys/mman.h>
-# else
-#  include <sys/lock.h>
-# endif
-#endif
-#endif
-
 #ifdef SYS_WINNT
 # include "ntservice.h"
 #endif
@@ -145,6 +135,13 @@
 # include <seccomp.h>
 #endif /* LIBSECCOMP and KERN_SECCOMP */
 
+#if defined(__FreeBSD__) &&  __FreeBSD_version < 1400037 && defined(HAVE_SYS_PROCCTL_H)
+# include <sys/procctl.h>
+# ifdef PROC_STACKGAP_DISABLE
+#  define DISABLE_FREEBSD_STACKGAP
+# endif
+#endif
+
 #ifdef HAVE_DNSREGISTRATION
 # include <dns_sd.h>
 DNSServiceRef mdns;
@@ -427,6 +424,24 @@ main(
 	char *argv[]
 	)
 {
+# ifdef DISABLE_FREEBSD_STACKGAP
+	/*
+	* We must disable ASLR stack gap on FreeBSD that has
+	* PROC_STACKGAP_DISABLE up through early FreeBSD 14
+	* versions to avoid a segfault. See:
+	* 
+	* https://bugs.ntp.org/3627
+	* https://cgit.freebsd.org/src/commit/?id=889b56c8cd84c9a9f2d9e3b019c154d6f14d9021
+	* https://cgit.freebsd.org/src/commit/?id=fc393054398ea50fb0cee52704e9385afe888b48
+	* https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=253208
+	* https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=241421
+	* https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=241960
+	*/
+	int aslr_var = PROC_STACKGAP_DISABLE;
+
+	procctl(P_PID, getpid(), PROC_STACKGAP_CTL, &aslr_var);
+# endif	/* DISABLE_FREEBSD_STACKGAP */
+
 	return ntpdmain(argc, argv);
 }
 #endif /* !SYS_WINNT */
@@ -560,7 +575,7 @@ set_process_priority(void)
 # ifdef HAVE_WORKING_FORK
 static void
 detach_from_terminal(
-	int pipe[2],
+	int pipes[2],
 	long wait_sync,
 	const char *logfilename
 	)
@@ -581,11 +596,10 @@ detach_from_terminal(
 			msyslog(LOG_ERR, "fork: %m");
 			exit_code = EX_OSERR;
 		} else {
-			close(pipe[1]);
-			pipe[1] = -1;
+			close(pipes[1]);
+			pipes[1] = -1;
 			exit_code = wait_child_sync_if(
-					pipe[0], wait_sync);
-			DPRINTF(1, ("sync_if: rc=%d\n", exit_code));
+					pipes[0], wait_sync);
 			if (exit_code <= 0) {
 				/* probe daemon exit code -- wait for
 				 * child process if we have an unexpected
@@ -593,7 +607,6 @@ detach_from_terminal(
 				 */
 				exit_code = wait_child_exit_if(
 						cpid, (exit_code < 0));
-				DPRINTF(1, ("exit_if: rc=%d\n", exit_code));
 			}
 		}
 		exit(exit_code);
@@ -610,8 +623,8 @@ detach_from_terminal(
 		syslog_file = NULL;
 		syslogit = TRUE;
 	}
-	close_all_except(pipe[1]);
-	pipe[0] = -1;
+	close_all_except(pipes[1]);
+	pipes[0] = -1;
 	INSIST(0 == open("/dev/null", 0) && 1 == dup2(0, 1) \
 		&& 2 == dup2(0, 2));
 
@@ -655,6 +668,7 @@ detach_from_terminal(
 	return;
 }
 # endif /* HAVE_WORKING_FORK */
+#endif /* !SIM && !SYS_WINNT */
 
 #ifdef HAVE_DROPROOT
 /*
@@ -793,7 +807,6 @@ set_user_group_ids(void)
 	return 1;
 }
 #endif /* HAVE_DROPROOT */
-#endif /* !SIM */
 
 /*
  * Main program.  Initialize us, disconnect us from the tty if necessary,
@@ -892,10 +905,13 @@ ntpdmain(
 	msyslog(LOG_NOTICE, "available at https://www.nwtime.org/support");
 	msyslog(LOG_NOTICE, "----------------------------------------------------");
 #ifdef DEBUG
-	msyslog(LOG_NOTICE, "DEBUG behavior is enabled - a violation of any");
-	msyslog(LOG_NOTICE, "diagnostic assertion will cause %s to abort", progname);
+	msyslog(LOG_NOTICE, "DEBUG behavior is enabled - a violation of any"
+			    " diagnostic assertion will cause %s to abort", 
+			    progname);
 #endif
 
+	ssl_check_version();
+
 	/*
 	 * Install trap handlers to log errors and assertion failures.
 	 * Default handlers print to stderr which doesn't work if detached.
@@ -1267,11 +1283,10 @@ ntpdmain(
 		 * is associated with running with uid 0 - should be refined on
 		 * ports that allow binding to NTP_PORT with uid != 0
 		 */
-		disable_dynamic_updates |= (sw_uid != 0);  /* also notifies routing message listener */
+		scan_addrs_once |= (sw_uid != 0);  /* used by routing socket code */
 #  endif /* !HAVE_LINUX_CAPABILITIES && !HAVE_SOLARIS_PRIVS */
 
-		if (disable_dynamic_updates && interface_interval) {
-			interface_interval = 0;
+		if (scan_addrs_once) {
 			msyslog(LOG_INFO, "running as non-root disables dynamic interface tracking");
 		}
 
@@ -1285,9 +1300,9 @@ ntpdmain(
 			cap_t caps;
 			char *captext;
 			
-			captext = (0 != interface_interval)
-				      ? "cap_sys_time,cap_net_bind_service=pe"
-				      : "cap_sys_time=pe";
+			captext = (scan_addrs_once)
+				    ? "cap_sys_time=pe"
+				    : "cap_sys_time,cap_net_bind_service=pe";
 			caps = cap_from_text(captext);
 			if (!caps) {
 				msyslog(LOG_ERR,
@@ -1424,10 +1439,9 @@ int scmp_sc[] = {
 	}
 #endif /* LIBSECCOMP and KERN_SECCOMP */
 
-#if defined(SYS_WINNT)
 	ntservice_isup();
-#elif defined(HAVE_WORKING_FORK)
-	if (daemon_pipe[1] != -1) {
+#if defined(HAVE_WORKING_FORK)
+	if (daemon_pipe[1] != -1 && 0 == wait_sync) {
 		if (2 != write(daemon_pipe[1], "R\n", 2)) {
 			msyslog(LOG_ERR, "daemon failed to notify parent ntpd after init");
 		}
@@ -1436,6 +1450,10 @@ int scmp_sc[] = {
 	}
 #endif /* HAVE_WORKING_FORK */
 
+	if (scan_addrs_once || no_periodic_scan) {
+		endpt_scan_timer = 0;
+	}
+
 # ifndef HAVE_IO_COMPLETION_PORT
 	BLOCK_IO_AND_ALARM();
 	was_alarmed = FALSE;
@@ -1674,29 +1692,31 @@ wait_child_sync_if(
 		}
 		rc = read(pipe_read_fd, &ch, 1);
 		if (rc == 0) {
-			DPRINTF(2, ("daemon control: got EOF\n"));
+			/* DPRINTF is useless here as -d/-D disable forking */
+			fprintf(stderr, "daemon control: got EOF\n");
 			return -1;	/* unexpected EOF, check daemon */
 		} else if (rc == 1) {
-			DPRINTF(2, ("daemon control: got '%c'\n",
-				    (ch >= ' ' ? ch : '.')));
-			if (ch == 'R' && !wait_sync)
-				return 0;
-			if (ch == 'S' && wait_sync)
+			if (   ('S' == ch && wait_sync > 0)
+			    || ('R' == ch && 0 == wait_sync)) {
 				return 0;
+			}
 		} else {
-			DPRINTF(2, ("daemon control: read 1 char failed: %s\n",
-				    strerror(errno)));
+			mfprintf(stderr, "%s: daemon control: read 1 char failed: %m\n",
+				 progname);
+			msyslog(LOG_ERR, "daemon control: read 1 char failed: %m");
 			return EX_IOERR;
 		}
 	} while (wait_rem > 0);
 
-	if (wait_sync) {
+	if (wait_sync > 0) {
 		fprintf(stderr, "%s: -w/--wait-sync %ld timed out.\n",
 			progname, wait_sync);
+		msyslog(LOG_ERR, "-w/--wait-sync %ld timed out.", wait_sync);
 		return EX_PROTOCOL;
 	} else {
 		fprintf(stderr, "%s: daemon startup monitoring timed out.\n",
 			progname);
+		msyslog(LOG_ERR, "daemon startup monitoring timed out.");
 		return 0;
 	}
 }
@@ -1712,7 +1732,6 @@ wait_child_exit_if(
 	int	rc = 0;
 	int	wstatus;
 	if (cpid == waitpid(cpid, &wstatus, (blocking ? 0 : WNOHANG))) {
-		DPRINTF(1, ("child (pid=%d) dead now\n", cpid));
 		if (WIFEXITED(wstatus)) {
 			rc = WEXITSTATUS(wstatus);
 			msyslog(LOG_ERR, "daemon child exited with code %d",
@@ -1725,8 +1744,6 @@ wait_child_exit_if(
 			rc = EX_SOFTWARE;
 			msyslog(LOG_ERR, "daemon child died with unknown cause");
 		}
-	} else {
-		DPRINTF(1, ("child (pid=%d) still alive\n", cpid));
 	}
 	return rc;
 #    else
diff --git a/contrib/ntp/ntpd/ntpd.man.in b/contrib/ntp/ntpd/ntpd.man.in
index addee5d56e77..2474c8d18d9b 100644
--- a/contrib/ntp/ntpd/ntpd.man.in
+++ b/contrib/ntp/ntpd/ntpd.man.in
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH ntpd @NTPD_MS@ "06 Jun 2023" "4.2.8p17" "User Commands"
+.TH ntpd @NTPD_MS@ "25 May 2024" "4.2.8p18" "User Commands"
 .\"
 .\" EDIT THIS FILE WITH CAUTION (in-mem file)
 .\"
-.\" It has been AutoGen-ed June 6, 2023 at 04:37:49 AM by AutoGen 5.18.16
+.\" It has been AutoGen-ed May 25, 2024 at 12:04:07 AM by AutoGen 5.18.16
 .\" From the definitions ntpd-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
@@ -979,7 +979,7 @@ RFC5908
 .SH "AUTHORS"
 The University of Delaware and Network Time Foundation
 .SH "COPYRIGHT"
-Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .SH BUGS
 The
diff --git a/contrib/ntp/ntpd/ntpd.mdoc.in b/contrib/ntp/ntpd/ntpd.mdoc.in
index 6d99fbcf5e7a..874a6c778ed7 100644
--- a/contrib/ntp/ntpd/ntpd.mdoc.in
+++ b/contrib/ntp/ntpd/ntpd.mdoc.in
@@ -1,9 +1,9 @@
-.Dd June 6 2023
+.Dd May 25 2024
 .Dt NTPD @NTPD_MS@ User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntpd-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  June  6, 2023 at 04:37:36 AM by AutoGen 5.18.16
+.\"  It has been AutoGen-ed  May 25, 2024 at 12:03:54 AM by AutoGen 5.18.16
 .\"  From the definitions    ntpd-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
@@ -886,7 +886,7 @@ A snapshot of this documentation is available in HTML format in
 .Sh "AUTHORS"
 The University of Delaware and Network Time Foundation
 .Sh "COPYRIGHT"
-Copyright (C) 1992\-2023 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992\-2024 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .Sh BUGS
 The
diff --git a/contrib/ntp/ntpd/refclock_acts.c b/contrib/ntp/ntpd/refclock_acts.c
index 944ac764ccff..709427d34e9e 100644
--- a/contrib/ntp/ntpd/refclock_acts.c
+++ b/contrib/ntp/ntpd/refclock_acts.c
@@ -897,5 +897,5 @@ acts_timecode(
 	pp->lastref = pp->lastrec;
 }
 #else
-int refclock_acts_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_arbiter.c b/contrib/ntp/ntpd/refclock_arbiter.c
index 7de613fa751e..b92e72361bb1 100644
--- a/contrib/ntp/ntpd/refclock_arbiter.c
+++ b/contrib/ntp/ntpd/refclock_arbiter.c
@@ -473,5 +473,5 @@ arb_poll(
 }
 
 #else
-int refclock_arbiter_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_arc.c b/contrib/ntp/ntpd/refclock_arc.c
index d2dba54cb462..73bb63bc408a 100644
--- a/contrib/ntp/ntpd/refclock_arc.c
+++ b/contrib/ntp/ntpd/refclock_arc.c
@@ -870,15 +870,18 @@ arc_receive(
 	struct recvbuf *rbufp
 	)
 {
+	static int quality_average = 0;
+	static int quality_sum = 0;
+	static int quality_polls = 0;
 	register struct arcunit *up;
 	struct refclockproc *pp;
 	struct peer *peer;
 	char c;
-	int i, n, wday, month, flags, status;
+	int i, wday, month, flags, status;
 	int arc_last_offset;
-	static int quality_average = 0;
-	static int quality_sum = 0;
-	static int quality_polls = 0;
+    #ifdef DEBUG
+	int n;
+    #endif
 
 	/*
 	 * Initialize pointers and read the timecode and timestamp
@@ -1182,8 +1185,8 @@ arc_receive(
 	status = pp->a_lastcode[15];
 #ifdef DEBUG
 	if(debug) { printf("arc: status 0x%.2x flags 0x%.2x\n", flags, status); }
-#endif
 	n = 9;
+#endif
 
 	/*
 	  Validate received values at least enough to prevent internal
diff --git a/contrib/ntp/ntpd/refclock_as2201.c b/contrib/ntp/ntpd/refclock_as2201.c
index d71284173cbb..bb485551bb6c 100644
--- a/contrib/ntp/ntpd/refclock_as2201.c
+++ b/contrib/ntp/ntpd/refclock_as2201.c
@@ -385,5 +385,5 @@ as2201_poll(
 }
 
 #else
-int refclock_as2201_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_atom.c b/contrib/ntp/ntpd/refclock_atom.c
index b3c0d6b46ab0..6e01352db982 100644
--- a/contrib/ntp/ntpd/refclock_atom.c
+++ b/contrib/ntp/ntpd/refclock_atom.c
@@ -235,5 +235,5 @@ atom_poll(
 	refclock_receive(peer);
 }
 #else
-int refclock_atom_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_bancomm.c b/contrib/ntp/ntpd/refclock_bancomm.c
index 577ad277213c..d0d855d57b22 100644
--- a/contrib/ntp/ntpd/refclock_bancomm.c
+++ b/contrib/ntp/ntpd/refclock_bancomm.c
@@ -617,5 +617,5 @@ stfp_time2tvme(struct vmedate *time_vme, struct stfp_time *stfp)
 	return;
 }
 #else
-int refclock_bancomm_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_chronolog.c b/contrib/ntp/ntpd/refclock_chronolog.c
index 1499ee4c81ed..4a8a4aa86efb 100644
--- a/contrib/ntp/ntpd/refclock_chronolog.c
+++ b/contrib/ntp/ntpd/refclock_chronolog.c
@@ -339,5 +339,5 @@ chronolog_poll(
 }
 
 #else
-int refclock_chronolog_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_conf.c b/contrib/ntp/ntpd/refclock_conf.c
index 30cc632065c8..ddabf932ea98 100644
--- a/contrib/ntp/ntpd/refclock_conf.c
+++ b/contrib/ntp/ntpd/refclock_conf.c
@@ -322,5 +322,5 @@ struct refclock * const refclock_conf[] = {
 u_char num_refclock_conf = sizeof(refclock_conf)/sizeof(struct refclock *);
 
 #else
-int refclock_conf_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif
diff --git a/contrib/ntp/ntpd/refclock_dumbclock.c b/contrib/ntp/ntpd/refclock_dumbclock.c
index 3563847dac05..37aaf28fa02a 100644
--- a/contrib/ntp/ntpd/refclock_dumbclock.c
+++ b/contrib/ntp/ntpd/refclock_dumbclock.c
@@ -373,5 +373,5 @@ dumbclock_poll(
 #endif
 
 #else
-int refclock_dumbclock_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif	/* defined(REFCLOCK) && defined(CLOCK_DUMBCLOCK) */
diff --git a/contrib/ntp/ntpd/refclock_fg.c b/contrib/ntp/ntpd/refclock_fg.c
index abcf43f9cb9e..9ded8c7e79e0 100644
--- a/contrib/ntp/ntpd/refclock_fg.c
+++ b/contrib/ntp/ntpd/refclock_fg.c
@@ -331,5 +331,5 @@ fg_receive(
 
 
 #else
-int refclock_fg_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_gpsvme.c b/contrib/ntp/ntpd/refclock_gpsvme.c
index 66ccc9a3ec90..3920b7a3cccc 100644
--- a/contrib/ntp/ntpd/refclock_gpsvme.c
+++ b/contrib/ntp/ntpd/refclock_gpsvme.c
@@ -249,5 +249,5 @@ check_leap_sec(struct refclockproc *pp, int unit)
 }
 
 #else
-int	refclock_gpsvme_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif	/* REFCLOCK	*/
diff --git a/contrib/ntp/ntpd/refclock_heath.c b/contrib/ntp/ntpd/refclock_heath.c
index e34fa6b93628..2d9aa45a5b6d 100644
--- a/contrib/ntp/ntpd/refclock_heath.c
+++ b/contrib/ntp/ntpd/refclock_heath.c
@@ -446,5 +446,5 @@ heath_poll(
 }
 
 #else
-int refclock_heath_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_hopfpci.c b/contrib/ntp/ntpd/refclock_hopfpci.c
index 95bcab983c4d..5b63e593fa2b 100644
--- a/contrib/ntp/ntpd/refclock_hopfpci.c
+++ b/contrib/ntp/ntpd/refclock_hopfpci.c
@@ -254,5 +254,5 @@ hopfpci_poll(
 }
 
 #else
-int refclock_hopfpci_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_hopfser.c b/contrib/ntp/ntpd/refclock_hopfser.c
index e8e5ecefdc40..6cc39c90b774 100644
--- a/contrib/ntp/ntpd/refclock_hopfser.c
+++ b/contrib/ntp/ntpd/refclock_hopfser.c
@@ -362,5 +362,5 @@ hopfserial_poll (
 }
 
 #else
-int refclock_hopfser_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_hpgps.c b/contrib/ntp/ntpd/refclock_hpgps.c
index fb7085a799e5..e9a87172136d 100644
--- a/contrib/ntp/ntpd/refclock_hpgps.c
+++ b/contrib/ntp/ntpd/refclock_hpgps.c
@@ -622,5 +622,5 @@ hpgps_poll(
 }
 
 #else
-int refclock_hpgps_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_irig.c b/contrib/ntp/ntpd/refclock_irig.c
index abc94f62e8fb..29cf5d6a748e 100644
--- a/contrib/ntp/ntpd/refclock_irig.c
+++ b/contrib/ntp/ntpd/refclock_irig.c
@@ -1039,5 +1039,5 @@ irig_gain(
 
 
 #else
-int refclock_irig_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_jjy.c b/contrib/ntp/ntpd/refclock_jjy.c
index c4e1697bfdf7..84956eb1da2a 100644
--- a/contrib/ntp/ntpd/refclock_jjy.c
+++ b/contrib/ntp/ntpd/refclock_jjy.c
@@ -4525,5 +4525,5 @@ printableString ( char *sOutput, int iOutputLen, const char *sInput, int iInputL
 /**************************************************************************************************/
 
 #else
-int refclock_jjy_bs ;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_jupiter.c b/contrib/ntp/ntpd/refclock_jupiter.c
index 7db0198ec692..4deac7401dc4 100644
--- a/contrib/ntp/ntpd/refclock_jupiter.c
+++ b/contrib/ntp/ntpd/refclock_jupiter.c
@@ -1028,5 +1028,5 @@ jupiter_recv(
 }
 
 #else /* not (REFCLOCK && CLOCK_JUPITER && HAVE_PPSAPI) */
-int refclock_jupiter_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* not (REFCLOCK && CLOCK_JUPITER && HAVE_PPSAPI) */
diff --git a/contrib/ntp/ntpd/refclock_local.c b/contrib/ntp/ntpd/refclock_local.c
index 8c0f74f62c24..62de1a98e84e 100644
--- a/contrib/ntp/ntpd/refclock_local.c
+++ b/contrib/ntp/ntpd/refclock_local.c
@@ -213,5 +213,5 @@ local_poll(
 	refclock_receive(peer);
 }
 #else
-int refclock_local_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_mx4200.c b/contrib/ntp/ntpd/refclock_mx4200.c
index 11c17d069dd4..0de856ee1edb 100644
--- a/contrib/ntp/ntpd/refclock_mx4200.c
+++ b/contrib/ntp/ntpd/refclock_mx4200.c
@@ -1635,5 +1635,5 @@ mx4200_send(peer, fmt, va_alist)
 }
 
 #else
-int refclock_mx4200_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_neoclock4x.c b/contrib/ntp/ntpd/refclock_neoclock4x.c
index a54381678310..a8c0a336307f 100644
--- a/contrib/ntp/ntpd/refclock_neoclock4x.c
+++ b/contrib/ntp/ntpd/refclock_neoclock4x.c
@@ -1057,7 +1057,7 @@ neol_check_firmware(int unit,
 #endif
 
 #else
-int refclock_neoclock4x_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
 
 /*
diff --git a/contrib/ntp/ntpd/refclock_nmea.c b/contrib/ntp/ntpd/refclock_nmea.c
index 131ccf641a56..a2d8d499156f 100644
--- a/contrib/ntp/ntpd/refclock_nmea.c
+++ b/contrib/ntp/ntpd/refclock_nmea.c
@@ -1408,6 +1408,7 @@ typedef unsigned char const UCC;
 
 static char const * const s_eof_chars = ",*\r\n";
 
+#ifdef DEBUG
 static int field_length(UCC *cp, unsigned int nfields)
 {
 	char const * ep = (char const*)cp;
@@ -1419,6 +1420,7 @@ static int field_length(UCC *cp, unsigned int nfields)
 	    ? (int)((UCC*)ep - cp)
 	    : (int)strlen((char const*)cp);
 }
+#endif	/* DEBUG */
 
 /* /[,*\r\n]/ --> skip */
 static int _parse_eof(UCC *cp, UCC ** ep)
diff --git a/contrib/ntp/ntpd/refclock_oncore.c b/contrib/ntp/ntpd/refclock_oncore.c
index d41d54023348..512e64b644da 100644
--- a/contrib/ntp/ntpd/refclock_oncore.c
+++ b/contrib/ntp/ntpd/refclock_oncore.c
@@ -4136,5 +4136,5 @@ oncore_log_f(
 }
 
 #else
-int refclock_oncore_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif	/* REFCLOCK && CLOCK_ONCORE */
diff --git a/contrib/ntp/ntpd/refclock_palisade.c b/contrib/ntp/ntpd/refclock_palisade.c
index a9fe2689575b..3a61d6012213 100644
--- a/contrib/ntp/ntpd/refclock_palisade.c
+++ b/contrib/ntp/ntpd/refclock_palisade.c
@@ -1567,5 +1567,5 @@ getsingle(
 }
 
 #else	/* REFCLOCK && CLOCK_PALISADE*/
-int refclock_palisade_c_notempty;
+NONEMPTY_TRANSLATION_UNIT
 #endif
diff --git a/contrib/ntp/ntpd/refclock_pcf.c b/contrib/ntp/ntpd/refclock_pcf.c
index 45b3475c0d68..4e92370ece10 100644
--- a/contrib/ntp/ntpd/refclock_pcf.c
+++ b/contrib/ntp/ntpd/refclock_pcf.c
@@ -223,5 +223,5 @@ pcf_poll(
 	refclock_receive(peer);
 }
 #else
-int refclock_pcf_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_pst.c b/contrib/ntp/ntpd/refclock_pst.c
index 1d3e1ffcfd6a..bd0f15938101 100644
--- a/contrib/ntp/ntpd/refclock_pst.c
+++ b/contrib/ntp/ntpd/refclock_pst.c
@@ -314,5 +314,5 @@ pst_poll(
 }
 
 #else
-int refclock_pst_int;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_ripencc.c b/contrib/ntp/ntpd/refclock_ripencc.c
index 789029f8aad5..a7339e3d4936 100644
--- a/contrib/ntp/ntpd/refclock_ripencc.c
+++ b/contrib/ntp/ntpd/refclock_ripencc.c
@@ -5250,6 +5250,6 @@ TranslateTSIPReportToText(
 #endif /* TRIMBLE_OUTPUT_FUNC */
 
 #else  /* defined(REFCLOCK) && defined(CLOCK_RIPENCC) */
-int refclock_ripencc_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* defined(REFCLOCK) && defined(CLOCK_RIPENCC) */
 
diff --git a/contrib/ntp/ntpd/refclock_tpro.c b/contrib/ntp/ntpd/refclock_tpro.c
index ac511bb4b392..9adcb5c6c7b3 100644
--- a/contrib/ntp/ntpd/refclock_tpro.c
+++ b/contrib/ntp/ntpd/refclock_tpro.c
@@ -204,5 +204,5 @@ tpro_poll(
 }
 
 #else
-int refclock_tpro_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_true.c b/contrib/ntp/ntpd/refclock_true.c
index 78e6adb9acaa..e41cd1351840 100644
--- a/contrib/ntp/ntpd/refclock_true.c
+++ b/contrib/ntp/ntpd/refclock_true.c
@@ -977,5 +977,5 @@ true_sample720(void)
 #endif
 
 #else
-int refclock_true_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_tsyncpci.c b/contrib/ntp/ntpd/refclock_tsyncpci.c
index e14a3fd122c5..49097ea72420 100644
--- a/contrib/ntp/ntpd/refclock_tsyncpci.c
+++ b/contrib/ntp/ntpd/refclock_tsyncpci.c
@@ -908,5 +908,5 @@ void DoyTimeFromSecTime(DoyTimeObj* pDt, SecTimeObj* pSt)
 } // End DoyTimeFromSecTime
 
 #else
-int refclock_tsyncpci_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_tt560.c b/contrib/ntp/ntpd/refclock_tt560.c
index 171ba5c8cc44..89bca13617f3 100644
--- a/contrib/ntp/ntpd/refclock_tt560.c
+++ b/contrib/ntp/ntpd/refclock_tt560.c
@@ -266,5 +266,5 @@ byte_swap(unsigned int input_num)
 }
 
 #else
-int refclock_tt560_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_ulink.c b/contrib/ntp/ntpd/refclock_ulink.c
index 60147adba219..c09638c21ca0 100644
--- a/contrib/ntp/ntpd/refclock_ulink.c
+++ b/contrib/ntp/ntpd/refclock_ulink.c
@@ -564,5 +564,5 @@ ulink_poll(
 }
 
 #else
-int refclock_ulink_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_wwv.c b/contrib/ntp/ntpd/refclock_wwv.c
index 2736cfa32fd7..f4098ae81cd7 100644
--- a/contrib/ntp/ntpd/refclock_wwv.c
+++ b/contrib/ntp/ntpd/refclock_wwv.c
@@ -2707,5 +2707,5 @@ wwv_gain(
 
 
 #else
-int refclock_wwv_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_wwvb.c b/contrib/ntp/ntpd/refclock_wwvb.c
index 6aafc26f1408..3720cdf80a1c 100644
--- a/contrib/ntp/ntpd/refclock_wwvb.c
+++ b/contrib/ntp/ntpd/refclock_wwvb.c
@@ -599,5 +599,5 @@ wwvb_control(
 #endif	/* HAVE_PPSAPI */
 
 #else
-int refclock_wwvb_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpd/refclock_zyfer.c b/contrib/ntp/ntpd/refclock_zyfer.c
index f77604868617..0ec566d5aec7 100644
--- a/contrib/ntp/ntpd/refclock_zyfer.c
+++ b/contrib/ntp/ntpd/refclock_zyfer.c
@@ -344,5 +344,5 @@ zyfer_poll(
 }
 
 #else
-int refclock_zyfer_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* REFCLOCK */
diff --git a/contrib/ntp/ntpdc/nl.pl b/contrib/ntp/ntpdc/nl.pl
index 9e79bf06a741..e65862f2f181 100755
--- a/contrib/ntp/ntpdc/nl.pl
+++ b/contrib/ntp/ntpdc/nl.pl
@@ -1,4 +1,5 @@
 #! /ntpbuild/bin/perl -w
+# ntpdc/nl.pl.  Generated from nl.pl.in by configure.
 
 $found = 0;
 $last = 0;
diff --git a/contrib/ntp/ntpdc/nl.pl.in b/contrib/ntp/ntpdc/nl.pl.in
index 8007538dc056..acf98d13a916 100644
--- a/contrib/ntp/ntpdc/nl.pl.in
+++ b/contrib/ntp/ntpdc/nl.pl.in
@@ -1,4 +1,5 @@
 #! @PATH_PERL@ -w
+# @configure_input@
 
 $found = 0;
 $last = 0;
diff --git a/contrib/ntp/ntpdc/ntpdc-opts.c b/contrib/ntp/ntpdc/ntpdc-opts.c
index 536d1b970f98..f1c637659bf6 100644
--- a/contrib/ntp/ntpdc/ntpdc-opts.c
+++ b/contrib/ntp/ntpdc/ntpdc-opts.c
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (ntpdc-opts.c)
  *
- *  It has been AutoGen-ed  June  6, 2023 at 04:37:53 AM by AutoGen 5.18.16
+ *  It has been AutoGen-ed  May 25, 2024 at 12:04:11 AM by AutoGen 5.18.16
  *  From the definitions    ntpdc-opts.def
  *  and the template file   options
  *
@@ -18,7 +18,7 @@
  * The ntpdc program is copyrighted and licensed
  * under the following terms:
  *
- *  Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation, all rights reserved.
+ *  Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation, all rights reserved.
  *  This is free software. It is licensed for use, modification and
  *  redistribution under the terms of the NTP License, copies of which
  *  can be seen at:
@@ -74,8 +74,8 @@ extern FILE * option_usage_fp;
  *  static const strings for ntpdc options
  */
 static char const ntpdc_opt_strs[2005] =
-/*     0 */ "ntpdc 4.2.8p17\n"
-            "Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation, all rights reserved.\n"
+/*     0 */ "ntpdc 4.2.8p18\n"
+            "Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation, all rights reserved.\n"
             "This is free software. It is licensed for use, modification and\n"
             "redistribution under the terms of the NTP License, copies of which\n"
             "can be seen at:\n"
@@ -136,14 +136,14 @@ static char const ntpdc_opt_strs[2005] =
 /*  1785 */ "no-load-opts\0"
 /*  1798 */ "no\0"
 /*  1801 */ "NTPDC\0"
-/*  1807 */ "ntpdc - vendor-specific NTPD control program - Ver. 4.2.8p17\n"
+/*  1807 */ "ntpdc - vendor-specific NTPD control program - Ver. 4.2.8p18\n"
             "Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]... [ host ...]\n\0"
 /*  1938 */ "$HOME\0"
 /*  1944 */ ".\0"
 /*  1946 */ ".ntprc\0"
 /*  1953 */ "https://bugs.ntp.org, bugs@ntp.org\0"
 /*  1988 */ "\n\0"
-/*  1990 */ "ntpdc 4.2.8p17";
+/*  1990 */ "ntpdc 4.2.8p18";
 
 /**
  *  ipv4 option description with
@@ -828,8 +828,8 @@ static void bogus_function(void) {
      translate option names.
    */
   /* referenced via ntpdcOptions.pzCopyright */
-  puts(_("ntpdc 4.2.8p17\n\
-Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation, all rights reserved.\n\
+  puts(_("ntpdc 4.2.8p18\n\
+Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation, all rights reserved.\n\
 This is free software. It is licensed for use, modification and\n\
 redistribution under the terms of the NTP License, copies of which\n\
 can be seen at:\n"));
@@ -897,14 +897,14 @@ implied warranty.\n"));
   puts(_("load options from a config file"));
 
   /* referenced via ntpdcOptions.pzUsageTitle */
-  puts(_("ntpdc - vendor-specific NTPD control program - Ver. 4.2.8p17\n\
+  puts(_("ntpdc - vendor-specific NTPD control program - Ver. 4.2.8p18\n\
 Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]... [ host ...]\n"));
 
   /* referenced via ntpdcOptions.pzExplain */
   puts(_("\n"));
 
   /* referenced via ntpdcOptions.pzFullVersion */
-  puts(_("ntpdc 4.2.8p17"));
+  puts(_("ntpdc 4.2.8p18"));
 
   /* referenced via ntpdcOptions.pzFullUsage */
   puts(_("<<<NOT-FOUND>>>"));
diff --git a/contrib/ntp/ntpdc/ntpdc-opts.h b/contrib/ntp/ntpdc/ntpdc-opts.h
index 47d3f481a54e..8f2638e55556 100644
--- a/contrib/ntp/ntpdc/ntpdc-opts.h
+++ b/contrib/ntp/ntpdc/ntpdc-opts.h
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (ntpdc-opts.h)
  *
- *  It has been AutoGen-ed  June  6, 2023 at 04:37:52 AM by AutoGen 5.18.16
+ *  It has been AutoGen-ed  May 25, 2024 at 12:04:11 AM by AutoGen 5.18.16
  *  From the definitions    ntpdc-opts.def
  *  and the template file   options
  *
@@ -18,7 +18,7 @@
  * The ntpdc program is copyrighted and licensed
  * under the following terms:
  *
- *  Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation, all rights reserved.
+ *  Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation, all rights reserved.
  *  This is free software. It is licensed for use, modification and
  *  redistribution under the terms of the NTP License, copies of which
  *  can be seen at:
@@ -92,9 +92,9 @@ typedef enum {
 /** count of all options for ntpdc */
 #define OPTION_CT    16
 /** ntpdc version */
-#define NTPDC_VERSION       "4.2.8p17"
+#define NTPDC_VERSION       "4.2.8p18"
 /** Full ntpdc version text */
-#define NTPDC_FULL_VERSION  "ntpdc 4.2.8p17"
+#define NTPDC_FULL_VERSION  "ntpdc 4.2.8p18"
 
 /**
  *  Interface defines for all options.  Replace "n" with the UPPER_CASED
